%searchInBigCodeBook
function annIdxList = searchInBigCodeBook(trainData, deformedTrain, nFold, inputSize)
  %deformedTrain = cell{1,10}
% idxOrg{1} = 1:5923;
% idxOrg{2} = 5924:12665;
% idxOrg{3} = 12666:18623;
% idxOrg{4} = 18624:24754;
% idxOrg{5} = 24755:30596;
% idxOrg{6} = 30597:36017;
% idxOrg{7} = 36018:41935;
% idxOrg{8} = 41936:48200;
% idxOrg{9} = 48201:54051;
% idxOrg{10} = 54052:60000;
annIdxList = cell(1, nFold);
  for idx1 = 1:5923
      curInput = repmat(trainData(idx1, :), nFold, 1);
      candidates1 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates1(i, :) = deformedTrain{1}(idx1+(i-1)*5923, :);
      end
      dist1 = Euclidean_Distance(candidates1, curInput);
      [tmp num] = min(dist1);
      annIdxList{1}(idx1, 1) = idx1+(num-1)*5923;
  end
  for idx2 = 5924:12665
      curInput = repmat(trainData(idx2, :), nFold, 1);
      candidates2 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates2(i, :) = deformedTrain{2}(idx2 - 5923 + (i-1)*6742, :);
      end
      dist2 = Euclidean_Distance(candidates2, curInput);
      [tmp num] = min(dist2);
      annIdxList{2}(idx2-5923, 1) = idx2 - 5923 + (num-1)*6742;
  end
  for idx3 = 12666:18623
      curInput = repmat(trainData(idx3, :), nFold, 1);
      candidates3 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates3(i, :) = deformedTrain{3}(idx3 - 12665 + (i-1)*5958, :);
      end
      dist3 = Euclidean_Distance(candidates3, curInput);
      [tmp num] = min(dist3);
      annIdxList{3}(idx3-12665, 1) = idx3 - 12665 + (num-1)*5958;
  end
  for idx4 = 18624:24754
      curInput = repmat(trainData(idx4, :), nFold, 1);
      candidates4 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates4(i, :) = deformedTrain{4}(idx4 - 18623 + (i-1)*6131, :);
      end
      dist4 = Euclidean_Distance(candidates4, curInput);
      [tmp num] = min(dist4);
      annIdxList{4}(idx4-18623, 1) = idx4 - 18623 + (num-1)*6131;
  end
  for idx5 = 24755:30569
      curInput = repmat(trainData(idx5, :), nFold, 1);
      candidates5 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates5(i, :) = deformedTrain{5}(idx5 - 24754 + (i-1)*5842, :);
      end
      dist5 = Euclidean_Distance(candidates5, curInput);
      [tmp num] = min(dist5);
      annIdxList{5}(idx5-24754, 1) = idx5 - 24754 + (num-1)*5842;
  end
  for idx6 = 30597:36017
      curInput = repmat(trainData(idx6, :), nFold, 1);
      candidates6 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates6(i, :) = deformedTrain{6}(idx6- 30596 +(i-1)*5421, :);
      end
      dist6 = Euclidean_Distance(candidates6, curInput);
      [tmp num] = min(dist6);
      annIdxList{6}(idx6-30596, 1) = idx6 - 30596 +(num-1)*5421;
  end
  for idx7 = 36018:41935%5918
      curInput = repmat(trainData(idx7, :), nFold, 1);
      candidates7 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates7(i, :) = deformedTrain{7}(idx7 - 36017 + (i-1)*5810, :);
      end
      dist7 = Euclidean_Distance(candidates7, curInput);
      [tmp num] = min(dist7);
      annIdxList{7}(idx7-36017, 1) = idx7 - 36017 + (num-1)*5810;
  end
  for idx8 = 41936:48200
      curInput = repmat(trainData(idx8, :), nFold, 1);
      candidates8 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates8(i, :) = deformedTrain{8}(idx8 - 41935 + (i-1)*6265, :);
      end
      dist8 = Euclidean_Distance(candidates8, curInput);
      [tmp num] = min(dist8);
      annIdxList{8}(idx8-41935, 1) = idx8 - 41935 + (num-1)*6265;
  end
  for idx9 = 48201:54051
      curInput = repmat(trainData(idx9, :), nFold, 1);
      candidates9 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates9(i, :) = deformedTrain{9}(idx9 - 48200 + (i-1)*5851, :);
      end
      dist9 = Euclidean_Distance(candidates9, curInput);
      [tmp num] = min(dist9);
      annIdxList{9}(idx9-48200, 1) = idx9 - 48200 + (num-1)*5851;
  end
  for idx10 = 54052:60000
      curInput = repmat(trainData(idx10, :), nFold, 1);
      candidates10 = zeros(nFold, inputSize);
      for i = 1:nFold
          candidates10(i, :) = deformedTrain{10}(idx10 - 54051 + (i-1)*5949, :);
      end
      dist10 = Euclidean_Distance(candidates10, curInput);
      [tmp num] = min(dist10);
      annIdxList{10}(idx10-54051, 1) = idx10 - 54051 + (num-1)*5949;
  end